#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

long long n;
long long A[3000005];
long long oprL[3000005];
long long oprR[3000005];

long long fenw[3000005];

void update(long long val)
{
    while(val<=n)
    {
        fenw[val]++;
        val+=(val&(-val));
    }
}

long long query(long long id)
{
    long long res=0;
    while(id)
    {
        res+=fenw[id];
        id-=(id&(-id));
    }
    return res;
}

long long query(long long le, long long ri)
{
    return query(ri)-query(le-1);
}

int32_t main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin>>n;
    long long totans=0;
    for(long long i=0; i<n; i++) cin>>A[i];
    for(long long i=0; i<n; i++)
    {
        update(A[i]);
        oprL[A[i]]+=query(A[i]+1, n);
        totans+=oprL[A[i]];
    }
    for(long long i=0; i<=n; i++) fenw[i]=0;
    for(long long i=n-1; i>=0; i--)
    {
        update(A[i]);
        oprR[A[i]]+=query(1, A[i]-1);
    }
    for(long long i=1; i<=n; i++)
    {
        oprR[i]+=oprR[i-1];
        oprL[i]+=oprL[i-1];
    
    }
    long long maxopr=totans;
    for(long long i=1; i<=n; i++)
    
    {
        if(maxopr>totans-oprL[i]+oprR[i-1]) maxopr=totans-oprL[i]+oprR[i-1];
    }
    cout<<maxopr<<endl;
    return 0;
}