/*
    Rugam na purva, neshto oturva, bah toz simson
    Toi na mene shte mi pravi kurvenski fason
*/

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 300000 + 10;
const int MAXLOG = 30;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, m;
int a[MAXN];
int min[MAXN];
int max[MAXN];
int dp[MAXN];
// int 

void solve()
{
    for (int idx = n ; idx > 1 ; --idx)
    {
        int at_least = idx;
        for (int i = 1 ; i < idx ; ++i)
        {
            at_least = std::max(at_least, max[i]);
        }

        dp[idx] = n;
        int cnt = 0;
        for (int j = idx ; j <= n ; ++j)
        {
            cnt += (min[j] >= idx);
            if (j >= at_least)
            {
                dp[idx] = std::min(dp[idx], dp[j + 1] + cnt);
            }
        }
    }

    std::cout << dp[2] << '\n';
}

void input()
{
    std::cin >> n >> m;
    std::fill(min + 1, min + 1 + n, n + 1);
    for (int i = 1 ; i <= m ; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        min[u] = std::min(min[u], v);
        max[u] = std::max(max[u], v);
        min[v] = std::min(min[v], u);
        max[v] = std::max(max[v], u);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}