#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const long long mod=1e9+7;

int n,m,a,b;
vector<int> v[MAXN];
int p[MAXN][20],dep[MAXN];

vector< pair<int,int> > e[MAXN];
vector<int> g[MAXN];

long long dp[MAXN];
int in[MAXN],ori[MAXN];

void dfs(int x,int par){
    p[x][0]=par;
    dep[x]=dep[par]+1;

    for(int i:v[x]){
        if(i==par)continue;
        dfs(i,x);
    }
}

pair<int,int> lca(int x,int y){
    if(dep[x]<dep[y])swap(x,y);

    for(int i=19;i>=0;i--){
        if((1<<i)<=dep[x]-dep[y])x=p[x][i];
    }

    if(x==y)return {x,x};

    for(int i=19;i>=0;i--){
        if(p[x][i]!=p[y][i] and p[x][i]!=0){
            x=p[x][i]; y=p[y][i];
        }
    }

    return {x,y};
}

void solve(int x){
    vector<int> ch;
    long long mult=1;

    for(int i:v[x]){
        if(i==p[x][0])continue;
        
        solve(i);
        ch.push_back(i);

        mult*=dp[i];
        mult%=mod;
    }

    if(ch.empty()){
        dp[x]=1; return;
    }

    sort(ch.begin(),ch.end());
    for(auto s:e[x])ori[s.second]++;

    do{
        for(auto s:e[x])in[s.second]=ori[s.second];

        for(int i=0;i<ch.size();i++){
            if(in[ch[i]]!=0)break;
            
            for(int f:g[ch[i]])in[f]--;
            if(i==int(ch.size())-1)dp[x]+=mult;
        }
    }while(next_permutation(ch.begin(),ch.end()));

    dp[x]%=mod;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;

    for(int i=1;i<=n-1;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    dfs(1,0);

    for(int j=1;j<20;j++){
        for(int i=1;i<=n;i++){
            p[i][j]=p[p[i][j-1]][j-1];
        }
    }

    for(int i=1;i<=m;i++){
        cin>>a>>b;

        auto s=lca(a,b);

        if(s.first==s.second){
            if(dep[a]>=dep[b]){
                cout<<1/0<<"\n";
                return 0;
            }
        }else{
            e[p[s.first][0]].push_back(s);
            g[s.first].push_back(s.second);
        }
    }

    solve(1);
    cout<<dp[1]<<"\n";

    return 0;
}

