#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const long long mod=1e9+7;

int n,m,a,b;
vector<int> v[MAXN];
int p[MAXN][20],dep[MAXN];

vector< pair<int,int> > e[MAXN];
vector<int> g[MAXN];

long long dp[MAXN];
int in[MAXN],ori[MAXN];

void dfs(int x,int par){
    p[x][0]=par;
    dep[x]=dep[par]+1;

    for(int i:v[x]){
        if(i==par)continue;
        dfs(i,x);
    }
}

pair<int,int> lca(int x,int y){
    if(dep[x]<dep[y])swap(x,y);

    for(int i=19;i>=0;i--){
        if((1<<i)<=dep[x]-dep[y])x=p[x][i];
    }

    if(x==y)return {x,x};

    for(int i=19;i>=0;i--){
        if(p[x][i]!=p[y][i] and p[x][i]!=0 and p[y][i]!=0){
            x=p[x][i]; y=p[y][i];
        }
    }

    return {x,y};
}

vector<int> ch;
int position[MAXN];
int dp2[(1<<13)];
int li[(1<<13)],tim;

int ff(int mask){
    if(mask==0)return 1;

    if(li[mask]==tim)return dp2[mask];
    li[mask]=tim;
    dp2[mask]=0;

    for(int i=0;i<ch.size();i++){
        if(((1<<i)&mask)==0)continue;

        bool ok=true;
        for(int f:g[ch[i]]){
            if((1<<position[f])&mask){
                ok=false; break;
            }
        }

        if(ok)dp2[mask]+=ff(mask^(1<<i));
    }

    dp2[mask]%=mod;
    return dp2[mask];
}

void solve(int x){
    long long mult=1;

    for(int i:v[x]){
        if(i==p[x][0])continue;

        solve(i);

        mult*=dp[i];
        mult%=mod;
    }

    ch.clear(); tim++;
    for(int i:v[x]){
        if(i==p[x][0])continue;

        ch.push_back(i);
        position[i]=int(ch.size())-1;
    }

    dp[x]=(long long) ff(((1<<int(ch.size()))-1))*mult;
    dp[x]%=mod;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;

    for(int i=1;i<=n-1;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    dfs(1,0);

    for(int j=1;j<20;j++){
        for(int i=1;i<=n;i++){
            p[i][j]=p[p[i][j-1]][j-1];
        }
    }

    for(int i=1;i<=m;i++){
        cin>>a>>b;

        auto s=lca(a,b);

        if(s.first==s.second){
            if(dep[a]>=dep[b]){
                cout<<0<<"\n";
                return 0;
            }
        }else{
            if(dep[a]<dep[b])swap(s.first,s.second);

            g[s.second].push_back(s.first);
        }
    }

    solve(1);
    cout<<dp[1]<<"\n";

    return 0;
}

