#include <bits/stdc++.h>
#define endl "\n"

#define maxn 2005

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}



int a[maxn][maxn];
int n, m;

int q;


void read()
{
    cin >> n >> m;

    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            a[i][j] = (i & j);
}

int dx[4] = {1, -1, 0, 0};
int dy[4] = {0, 0, 1, -1};
bool used[maxn][maxn];

int x1 , x2;
int _y1 , y2;

void dfs(int i, int j)
{
    //cout << i << " " << j << endl;

    used[i][j] = 1;
    for(int k = 0; k < 4; k++)
    {
        int nbi = i + dx[k];
        int nbj = j + dy[k];

        if(nbi >= x1 && nbi <= x2 && nbj >= _y1 && nbj <= y2 && used[nbi][nbj] == 0 && a[nbi][nbj] == 0)
            dfs(nbi, nbj);
    }
}


void answer()
{
    cin >> q;


    while(q--)
    {

        //cout << "_-_-_-" << endl;
        cin >> x1 >> _y1 >> x2 >> y2;
        //cout << 1 << endl;;

        int ans = 0;

        for(int i = x1; i <= x2; i++)
            for(int j = _y1; j <= y2; j++)
                if(used[i][j] == 0 && a[i][j] == 0)
                {
                    //cout << "-----------------------" << endl;
                    ans ++;
                    dfs(i, j);
                }


        for(int i = x1; i <= x2; i++)
            for(int j = _y1; j <= y2; j++)
                used[i][j] = 0;

        cout << ans << endl;
    }
}








int main()
{
    speed();///mazna

    read();
    answer();

    return 0;
}
