#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

const int MAXN = 3e6+5;

int n,a[MAXN];
int pos[MAXN];

long long pref[MAXN],suff[MAXN];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
        pos[a[i]] = i;
    }


}

int tree[MAXN];
int ql,qr;

void update(int pos)
{
    for(int idx = pos; idx <= n; idx += (idx & -idx))
    {
        tree[idx]++;
    }
}

int query(int pos)
{
    int result = 0;

    for(int idx = pos; idx >= 1; idx -= (idx & -idx))
    {
        result += tree[idx];
    }
    return result;
}

int query(int left, int right)
{
    return query(right) - query(left - 1);
}

void pre()
{
    long long pom = 0;
    for(int i = 1; i <= n; i++)
    {
        ql = pos[i];
        qr = n;
        pom += query(ql, qr);

        pref[i] = pom;

        ql = qr = pos[i];
        update(ql);
    }

    memset(tree,0,sizeof(tree));

    pom = 0;
    for(int i = n; i >= 1; i--)
    {
        ql = 1;
        qr = pos[i];
        pom += query(ql, qr);

        suff[i] = pom;

        ql = qr = pos[i];
        update(ql);
    }
}

void solve()
{
    pre();

    long long ans = 1e18;
    for(int i = 1; i <= n; i++)
    {
        ans = min(ans,pref[i-1] + suff[i+1]);
    }
    cout << ans << endl;
}

int main()
{
    speed();///mazna
    read();
    solve();
    return 0;
}
