#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 3e6 + 10;

int n;
pair < int, int > a[MAXN];
int fen[MAXN];

void update(int pos, int val)
{
    for (int i = pos; i <= n; i += (i & -i))
        fen[i] += val;
}

int sum(int pos)
{
    int s = 0;
    for (int i = pos; i > 0; i -= (i & -i))
    {

        s += fen[i];
    }
    return s;
}

ll pref[MAXN], suff[MAXN];
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i].first;
        a[i].second = i;
    }

    sort(a + 1, a + n + 1);
    for (int i = 1; i <= n; i ++)
    {
        pref[i] = pref[i - 1] + (i - 1 - sum(a[i].second));
        update(a[i].second, 1);

    }

    for (int i = 1; i <= n; i ++)
    {

        update(a[i].second, - 1);
    }

    for (int i = n; i > 0; i --)
    {

        suff[i] = suff[i + 1] + (sum(a[i].second));
        update(a[i].second, 1);
    }

    ll result = n * n;
    for (int i = 1; i <= n; i ++)
    {

        result = min(result, pref[i - 1] + suff[i + 1]);
    }

    cout << result << endl;

}

int main()
{
speed();
    solve();

    return 0;
}
