#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 2e5 + 10;

int n;
ll h[MAXN], pref[MAXN];
int dp[1010][1010], from[1010][1010];

void solve_dp(int l, int r)
{
    if ((pref[r] - pref[l - 1]) * n > (pref[n]) * (ll)(r - l + 1))
    {

        dp[l][r] = -1;
        from[l][r] = 0;
        return;
    }
    /// (pref[r] - pref[l - 1]) / (r - l + 1) > (pref[n]) / n
    if (l == r)
    {

        dp[l][r] = 1;
        from[l][r] = 0;
        return;
    }

    if (dp[l + 1][r] == 0)
        solve_dp(l + 1, r);
    if (dp[l][r - 1] == 0)
        solve_dp(l, r - 1);

    if (dp[l + 1][r] == 1)
    {
        dp[l][r] = 1;
        from[l][r] = -1; /// left;
    }
    else
    if (dp[l][r - 1] == 1)
    {
        dp[l][r] = 1;
        from[l][r] = 1; /// right;
    }
    else
    {
        dp[l][r] = -1;
        from[l][r] = 0;
    }

    ///cout << "state " << l << " " << r << " " << dp[l][r] << endl;
}

double v[MAXN];
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        cin >> h[i];
        pref[i] = pref[i - 1] + h[i];
    }


    double avg = (double)(pref[n]) / (double)(n);

    for (int i = 1; i <= n; i ++)
        v[i] =  (double)(h[i]) / avg;

    h[0] = 1e18;
    h[n + 1] = 1e18;
    int s1 = -1, s2 = -1;
    for (int i = 1; i <= n; i ++)
    {
        if (h[i] <= h[i - 1] && h[i] <= h[i + 1])
        {
            if (s1 == -1)
                s1 = i;
            else
                s2 = i;
        }
    }

    int l = s1, r = s2;
    double sum = v[s1];
    vector < int > ord;
    ord.push_back(l);
    while(l - 1 > 0 && v[l - 1] <= 0)
    {
        ord.push_back(l - 1);
        sum += v[l - 1];
        l --;
    }
    while(r + 1 <= n && v[r + 1] <= 0)
    {
        sum += v[r + 1];
        ord.push_back(r + 1);
        r ++;
    }

    bool tf = true;
    while(r < s2)
    {
        if (sum + v[r + 1] > 0)
        {
            tf = false;
            break;
        }

        ord.push_back(r + 1);
        sum += v[r + 1];
        r ++;
    }

    if (tf)
    {
        while(r < n)
        {
            r ++;
            ord.push_back(r);
        }
        while(l > 1)
        {
            l --;
            ord.push_back(l);
        }

        for (int cur : ord)
            cout << cur << " ";
        cout << endl;
        return;
    }

    tf = true;
    ord.clear();
    l = r = s2;
    sum =  v[l];
    ord.push_back(l);
    while(l - 1 > 0 && v[l - 1] <= 0)
    {
        ord.push_back(l - 1);
        sum += v[l - 1];
        l --;
    }
    while(r + 1 <= n && v[r + 1] <= 0)
    {
        sum += v[r + 1];
        ord.push_back(r + 1);
        r ++;
    }


    while(l > s1)
    {
        if (sum + v[l - 1] > 0)
        {

            tf = false;
            break;
        }
        l --;
        sum += v[l];
        ord.push_back(l);
    }


    if (tf)
    {
        while(r < n)
        {
            r ++;
            ord.push_back(r);
        }
        while(l > 1)
        {
            l --;
            ord.push_back(l);
        }

        for (int cur : ord)
            cout << cur << " ";
        cout << endl;
        return;
    }

    cout << "impossible" << endl;


}

int main()
{
    solve();

    return 0;
}
