#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;
const double eps = 1e-4;

int n;
long long a[maxn];
double avg;

bool isBigger(double x, double y)
{
    return x - y > -eps; ///eps
}

void f(int pos)
{
    if (isBigger(a[pos], avg)) return;

    int l = pos - 1;
    int r = pos + 1;
    long long sum = a[pos];
    int cnt = 1;

    vector<int> nas;
    nas.push_back(pos);

    while (true)
    {
        if (l == 0 && r == n + 1) break;

        if (l == 0)
        {
            sum += a[r];
            nas.push_back(r);
            ++r;
        }
        else if (r == n + 1)
        {
            sum += a[l];
            nas.push_back(l);
            --l;
        }
        else if (a[l] < a[r])
        {
            sum += a[l];
            nas.push_back(l);
            --l;
        }
        else
        {
            sum += a[r];
            nas.push_back(r);
            ++r;
        }

        ++cnt;
        double currAvg = ((1.0 * sum) / (1.0 * cnt));

        if (isBigger(currAvg, avg)) return;
    }

    for (auto i : nas) cout << i << " ";
    cout << endl;
    exit(0);
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    long long sum = 0;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sum += a[i];
    }

    avg = ((sum * 1.0) / (n * 1.0));

    for (int i = 1; i <= n; ++i)
    {
        f(i);
    }

    cout << "impossible" << endl;

    return 0;
}
