#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;
const int MAXLOG=20;
const int MOD=1e9+7;

int n,m;
vector<int> adj[MAXN];
int par[MAXN][MAXLOG];
int depth[MAXN];
vector<pair<int,int> > rul[MAXN];
int t[MAXN];
long long ans=1;

void dfs(int v)
{
    for(auto u: adj[v])
    {
        if(u==par[v][0]) continue;
        par[u][0]=v;
        depth[u]=depth[v]+1;
        dfs(u);
    }
}

pair<pair<int,int>,int> lca(int u,int v)
{
    if(depth[u]>depth[v])
    {
        for(int i=16;i>=0;i--)
        {
            if(depth[par[u][i]]>=depth[v]) u=par[u][i];
        }
        if(u==v) return {{-1,-1},-1};
    }
    else if(depth[v]>depth[u])
    {
        for(int i=16;i>=0;i--)
        {
            if(depth[par[v][i]]>=depth[u]) v=par[v][i];
        }
        return {{0,0},0};
    }

    for(int i=16;i>=0;i--)
    {
        if(par[u][i]!=par[v][i])
        {
            u=par[u][i];
            v=par[v][i];
        }
    }
    if(par[u][0]==v) return {{-1,-1},-1};
    if(par[v][0]==u) return {{0,0},0};
    return {{u,v},par[u][0]};
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>m;
    for(int i=1;i<n;i++)
    {
        int u,v;
        cin>>u>>v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    par[1][0]=0;
    depth[1]=1;
    dfs(1);

    for(int i=1;(1<<i)<n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            par[j][i]=par[par[j][i-1]][i-1];
            //cout<<j<<" "<<i<<": "<<par[j][i]<<endl;
        }
    }

    bool fl=0;
    for(int i=0;i<m;i++)
    {
        int u,v;
        cin>>u>>v;
        auto cur=lca(u,v);
        u=cur.fi.fi;
        v=cur.fi.se;
        int w=cur.se; /// dete u e predi dete v, te sa deca na w
        //cout<<u<<" "<<v<<" "<<w<<endl;

        if(u==-1) {fl=1; continue;}
        if(u==0) continue;

        rul[w].push_back({u,v});
    }

    if(fl)
    {
        cout<<0<<endl;
        return 0;
    }

    for(int i=1;i<=n;i++)
    {
        int deg=adj[i].size();
        if(i>1) deg--;
        if(deg<=1) continue;

        //cout<<i<<": ";
        //for(auto x: rul[i]) cout<<x.fi<<","<<x.se<<"  ";
        //cout<<endl;

        vector<int> cur;
        for(auto u: adj[i])
        {
            if(u==par[i][0]) continue;
            cur.push_back(u);
        }
        sort(cur.begin(), cur.end());
        int cnt=0;
        do
        {
            for(int j=0;j<cur.size();j++) t[cur[j]]=j;
            bool fl1=0;
            for(auto x: rul[i])
            {
                if(t[x.fi]>t[x.se])
                {
                    fl1=1;
                    break;
                }
            }
            if(fl1==0) cnt++;
        }while(next_permutation(cur.begin(), cur.end()));

        ans=ans*cnt%MOD;
    }

    cout<<ans<<endl;

    return 0;
}
