#include <bits/stdc++.h>
#define MAXN 2008
#define endl '\n'
using namespace std;
bool t[2008][2008];
queue<pair<int,int>> q;
pair<int,int> dirs[] = { {1, 0}, {0, 1}, {-1, 0}, {0, -1} };
bool used[2008][2008];
int pr[MAXN][MAXN];
void bfs(int x, int y, int r1, int c1, int r2, int c2)
{
    q.push({x, y});
    while (!q.empty())
    {
        int r = q.front().first;
        int c = q.front().second;
        q.pop();

        for (auto dir : dirs)
        {
            int rr = r + dir.first;
            int cc = c + dir.second;

            if ( rr < r1 || rr > r2) continue;
            if ( cc < c1 || cc > c2 ) continue;
            if ( used[rr][cc] ) continue;
            if ( t[rr][cc] == 1 ) continue;

            used[rr][cc] = true;
            q.push({rr, cc});
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    for (int i=0; i<n; i++)
        for (int j=0; j<m; j++)
        {
            t[i][j] = (i & j);
        }

    for (int i=0; i<n; i++)
        for (int j=0; j<m; j++)
        {
            if ( j )
            {
                pr[i][j] = pr[i][j-1] + (( t[i][j]==0 && t[i][j-1] == 1)? 1: 0);
            }
            else pr[i][j] = (t[i][j]==0)? 1 : 0;

        }

/**

    for (int i=0; i<n; i++)
    {
        for (int j=0; j<m; j++)
        {
            cerr << t[i][j];
        }
        cerr << endl;
    }
    cerr << "pr\n";
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<m; j++)
        {
            cerr << pr[i][j];
        }
        cerr << endl;
    }*/
    for (int h=0; h<q; h++)
    {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        if ( r1 == r2 )
        {
            if ( c1 ) cout << pr[r1][c2] - pr[r1][c1-1] << endl;
            else cout << pr[r1][c2] << endl;
        }
        else
        {
            for (int i=r1; i<=r2; i++) memset(used[i], false, sizeof(used[i]));

            int ans = 0;
            for (int i=r1; i<=r2; i++)
                for (int j=c1; j<=c2; j++)
                {
                    if ( !used[i][j] && t[i][j] == 0)
                    {
                        ans++;
                        bfs(i, j, r1, c1, r2, c2);
                    }
                }

            cout << ans << endl;
        }

    }
}
/**
6 5 6
0 0 3 2
0 2 1 3
0 1 2 4
5 4 5 4
0 0 0 4
1 0 2 4
-------------
1
1
2
0
1
3
*/
