#include <bits/stdc++.h>
#define MAXN  200008
#define endl '\n'
using namespace std;
//!  not connected???  for every component bfs and we have to connect it just before the bfs
int level[MAXN];
int minzad[MAXN];
queue<int> q;
vector<int> edges[MAXN];
bool used[MAXN]; int n;
void bfs(int s)
{
    cerr << "bfs(" << s << ")--------------\n";
    q.push(s);
    level[0] = 0;
    while (!q.empty())
    {
        int curr = q.front();
        q.pop();
        for (auto next : edges[curr])
        {
            if ( used[next] ) continue;
            used[next] = true;
            q.push(next);
            level[next] = level[curr] + 1;
            minzad[next] = level[next];
        }
    }

    //update minzad
    int mini = -1;
    for (int i=n; i>=1; i--)
    {
        if ( minzad[i] != -1 )
        {
            if ( mini == -1 || minzad[i] < mini ) mini = minzad[i];
            minzad[i] = mini;
        }
    }


    for (int i=0; i<=n; i++)
    {
        cerr << level[i] << " ";
    }
    cerr << endl;
    for (int i=0; i<=n; i++)
    {
        cerr << minzad[i] << " ";
    }
    cerr << endl;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    for (int j=0; j<m; j++)
    {
        int b, e;
        cin >> b >> e;
        edges[b].push_back(e);
        edges[e].push_back(b);
    }
    memset(minzad, -1, sizeof(minzad));
    memset(level, -1, sizeof(level));
    int ans = -1;
    for (int r=1; r<=n; r++)
    {
        if ( !used[r] )
        {
            //!connect
            ans++;
            edges[r].push_back(r-1);
            edges[r-1].push_back(r);
            //----------------------------
            memset(used, false, sizeof(used)); //maybe error no neeeeee
            bfs(r-1);
            int start = r;
            bool flag = true;
            while (flag)
            {
                flag = false;
                for (int i=start; i<=n; i++)
                {
                    if ( level[i] < minzad[i] )
                    {
                        for (int j=i-1; j>=1; j--)
                        {
                            if ( level[j] == minzad[i] - 2 )
                            {
                                ans++;
                                edges[i].push_back(j);
                                edges[j].push_back(i);
                                level[i] = level[j] + 1;
                                bfs(i);
                                flag = true;
                                start = i;
                                break;
                            }
                        }
                    }
                    if (flag) break;
                }
            }
            //ready
        }
    }

    cout << ans << endl;

    return 0;
}

