/*
    Rugam na purva, neshto oturva, bah toz simson
    Toi na mene shte mi pravi kurvenski fason
*/

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 100000 + 10;
const int MAXLOG = 30;
const llong INF = 1e18;
const int INTINF = 1e9;

llong to;
llong num;
int dp[MAXLOG][2];
bool bl[MAXLOG][2];

int f(int bit, int equal)
{
    if (bit == -1)
    {
        return 0;
    }

    if (bl[bit][equal])
    {
        return dp[bit][equal];
    }

    bl[bit][equal] = true;
    dp[bit][equal] = 0;

    bool can_put_one = (!equal) || ((to & (1LL << bit)) > 0);
    // std::cout << "bit: " << bit << ' ' << equal << ' ' << can_put_one << '\n';
    if (bit > 0 && (num & ((1LL << bit) - 1)) > 0 && ((num & (1LL << bit)) == 0) && (!equal || ((to & ((1LL << bit + 1) - 1)) >= (1LL << bit) - 1))) 
    {
        // std::cout << "increment: " << bit << ' ' << equal << ' ' << (to & ((1LL << bit + 1) - 1)) << "\n";
        dp[bit][equal]++;
    }

    dp[bit][equal] += f(bit - 1, !can_put_one);
    if ((!(num & (1LL << bit))) && can_put_one)
    {
        dp[bit][equal] += f(bit - 1, equal);    
    }

    // std::cout << "dp: " << bit << ' ' << equal << " = " << dp[bit][equal] << ' ' << can_put_one << '\n';
    return dp[bit][equal];
}

int calc(int number, int l, int r)
{
    if (l > r)
    {
        return 0;
    }
    
    num = number;
    to = r;
    memset(bl, 0, sizeof(bl));
    memset(dp, 0, sizeof(dp));
    int ans = f(MAXLOG - 1, 1);
    // std::cout << "to: " << r << ' ' << ans << '\n';
    if (l > 0)
    {
        to = l - 1;
        memset(bl, 0, sizeof(bl));
        memset(dp, 0, sizeof(dp));
        ans -= f(MAXLOG - 1, 1);
    }

    return ans;
}

void solve()
{
    int n, m, q;
    std::cin >> n >> m >> q;
    for (int i = 1 ; i <= q ; ++i)
    {
        int a, b, c, d;
        std::cin >> a >> b >> c >> d;
        if (a == 0 && b == 0)
        {
            std::cout << 1 << '\n';
            continue;
        }

        int cnt = ((a & b) == 0) + calc(b, a, c - 1) + calc(a, b, d - 1);
        // std::cout << calc(b, a, c - 1) << '\n';
        std::cout << cnt << '\n';
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    solve();

    return 0;
}