/*
    Rugam na purva, neshto oturva, bah toz simson
    Toi na mene shte mi pravi kurvenski fason
*/

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 300000 + 10;
const int MAXLOG = 30;
const llong INF = 1e18;
const int INTINF = 1e9;

int n;
int a[MAXN];
int dp[MAXN];

void solve()
{
    int ans = n;
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 0 ; j < i ; ++j)
        {
            if (a[i] >= a[j])
            {
                dp[i] = std::max(dp[i], dp[j] + 1);
            }
        }

        ans = std::min(ans, n - dp[i]);
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}