#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

const int MAXN = 3e6+5;

int n,a[MAXN];
int pos[MAXN];

long long pref[MAXN],suff[MAXN];

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
        pos[a[i]] = i;
    }


}

int tree[4*MAXN];
int ql,qr;

void update(int v, int l, int r)
{
    if(r<ql || qr < l || l > r) return;
    if(ql <= l && r <= qr)
    {
        tree[v]++;
        return;
    }
    int mid = (l+r)/2;
    update(v*2+0,l,mid+0);
    update(v*2+1,mid+1,r);

    tree[v] = tree[v*2+0] + tree[v*2+1];
}

int query(int v, int l, int r)
{
    if(r<ql || qr < l || l > r) return 0;
    if(ql <= l && r <= qr) return tree[v];
    int mid = (l+r)/2;
    return query(v*2+0,l,mid+0) + query(v*2+1,mid+1,r);
}
void pre()
{
    long long pom = 0;
    for(int i = 1; i <= n; i++)
    {
        ql = pos[i];
        qr = n;
        pom += query(1,1,n);

        pref[i] = pom;

        ql = qr = pos[i];
        update(1,1,n);
    }

    memset(tree,0,sizeof(tree));

    pom = 0;
    for(int i = n; i >= 1; i--)
    {
        ql = 1;
        qr = pos[i];
        pom += query(1,1,n);

        suff[i] = pom;

        ql = qr = pos[i];
        update(1,1,n);
    }
}

void solve()
{
    pre();

    long long ans = 1e18;
    for(int i = 1; i <= n; i++)
    {
        ans = min(ans,pref[i-1] + suff[i+1]);
    }
    cout << ans << endl;
}

int main()
{
    speed();///mazna
    read();
    solve();
    return 0;
}
