#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 2e3 + 10;;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m, q;

int qrow1, qrow2, qc1, qc2;

bool in_range(int i, int j)
{
    return (i <= qrow2 && i >= qrow1 &&  j >= qc1 &&  j <= qc2);
}
int used[MAXN][MAXN];
void dfs(int i, int j)
{
    if(i&j)return;
    if(!in_range(i, j))return;
    if(used[i][j])return;
    used[i][j] = 1;
    dfs(i+1, j);
    dfs(i-1, j);
    dfs(i, j-1);
    dfs(i, j+1);
}

void queries()
{
    while(q --)
    {
        cin >> qrow1 >> qc1 >> qrow2 >> qc2;
         for (int i = qrow1; i <= qrow2; ++ i)
        {
            for (int j = qc1; j <= qc2; ++ j)
            {
                used[i][j] = 0;
            }
        }
        int cnt = 0;
        for (int i = qrow1; i <= qrow2; ++ i)
        {
            for (int j = qc1; j <= qc2; ++ j)
            {
                if(!used[i][j] && !(i&j))
                {
                    cnt ++;
                    //cout << " start at " << i << " " << j << endl;
                    dfs(i, j);
                }
            }

        }
        assert(cnt < 4);
        cout << cnt << endl;
    }

}


int main()
{
    speed();

    cin >> n >> m >> q;

    queries();
    return 0;
}
