#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 2e5 + 10;

int n;
ll h[MAXN], pref[MAXN];
int dp[1010][1010], from[1010][1010];

void solve_dp(int l, int r)
{
    if ((pref[r] - pref[l - 1]) * n > (pref[n]) * (ll)(r - l + 1))
    {

        dp[l][r] = -1;
        from[l][r] = 0;
        return;
    }
    /// (pref[r] - pref[l - 1]) / (r - l + 1) > (pref[n]) / n
    if (l == r)
    {

        dp[l][r] = 1;
        from[l][r] = 0;
        return;
    }

    if (dp[l + 1][r] == 0)
        solve_dp(l + 1, r);
    if (dp[l][r - 1] == 0)
        solve_dp(l, r - 1);

    if (dp[l + 1][r] == 1)
    {
        dp[l][r] = 1;
        from[l][r] = -1; /// left;
    }
    else
    if (dp[l][r - 1] == 1)
    {
        dp[l][r] = 1;
        from[l][r] = 1; /// right;
    }
    else
    {
        dp[l][r] = -1;
        from[l][r] = 0;
    }

    ///cout << "state " << l << " " << r << " " << dp[l][r] << endl;
}

void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        cin >> h[i];
        pref[i] = pref[i - 1] + h[i];
    }


    solve_dp(1, n);

    if (dp[1][n] == -1)
    {

        cout << "impossible" << endl;
        return;
    }


    vector < int > res;
    int l = 1, r = n;
    while(l != r)
    {

        if (from[l][r] == -1)
        {

            res.push_back(l);
            l ++;
        }
        else
        {

            res.push_back(r);
            r --;
        }
    }

    res.push_back(l);

    reverse(res.begin(), res.end());
    for (int cur : res)
        cout << cur << " ";

    cout << endl;
}

int main()
{
    solve();

    return 0;
}
