#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 3e5 + 10;
int n, a[MAXN], bef[MAXN], aft[MAXN];

void compress_data()
{
    vector < pair < int, int >  > vec;
    for (int i = 1; i <= n; i ++)
        vec.push_back({a[i], i});

    sort(vec.begin(), vec.end());

    int idx = 0;
    for (int i = 0; i < n; i ++)
    {

        if (i == 0 || (vec[i].first != vec[i - 1].first))
        {
            idx ++;

        }a[vec[i].second] = idx;
    }
}
vector < int > pos[MAXN];

int tree[4 * MAXN], pref[MAXN];

void build_tree(int root, int left, int right)
{
    if (left == right)
    {
        tree[root] = pref[left] + aft[left];
        return;
    }

    int mid = (left + right) / 2;
    build_tree(root * 2, left, mid);
    build_tree(root * 2 + 1, mid + 1, right);

    tree[root] = max(tree[root * 2], tree[root * 2 + 1]);
}

int query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return -1e9;
    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return max(query(root * 2, left, mid, qleft, qright),
            query(root * 2 + 1, mid + 1, right, qleft, qright));
}


void solve()
{

    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];

    }
    compress_data();

    int m = 0;
    for (int i = 1; i <= n; i ++)
        m = max(m, a[i]);
    for (int i = 1; i <= n; i ++)
    {
        pos[a[i]].push_back(i);
    }


    for (int i = 1; i < m; i ++)
    {
        int pivot = 0;
        while(pivot < (int)(pos[i + 1].size()) && pos[i + 1][pivot] < pos[i].back())
                pivot ++;

        aft[i] = (int)(pos[i + 1].size()) - pivot;

        pivot = (int)(pos[i].size()) - 1;
        while(pivot >= 0 && pos[i][pivot] > pos[i + 1][0])
            pivot --;

        bef[i + 1] = pivot + 1;
    }

    /// single case
    int res = n;
    for (int i = 1; i <= m; i ++)
    {
        res = min(res, n - (int)(pos[i].size()));
        if (i == m)
            break;
        int pivot = 0;
        for (int j = 0; j < (int)(pos[i].size()); j ++)
        {

            while(pivot < (int)(pos[i + 1].size()) && pos[i + 1][pivot] < pos[i][j])
                pivot ++;

            int sum = j + 1 + (int)(pos[i + 1].size()) - pivot;
            res = min(res, n - sum);
        }
    }



    int pivot = 1;
    for (int i = 1; i <= m; i ++)
    {
        pref[i] = pref[i - 1] + (int)(pos[i].size());
    } build_tree(1, 1, n);
    /**for (int i = 1; i <= n; i ++)
        cout << a[i] << " ";
    cout << endl;*/
    for (int i = 1; i < m; i ++)
    {
        pivot = max(pivot, i);
        while(pivot + 1 <= m && pos[pivot + 1][0] > pos[pivot].back())
            pivot ++;
        //cout << i << " : " << pivot << endl;
        //cout << "query " << query(1 , 1, n, i, pivot) << endl;
        int cur = bef[i] - pref[i - 1] + query(1, 1, n, i, pivot);
        res = min(res, n - cur);

        /**int len = pos[i].size();
        for (int j = i + 1; j <= m; j ++)
        {
            if (pos[j][0] < pos[j - 1].back())
                break;
            len += pos[j].size();
            if (n - (len + bef[i] + aft[j]) < res)
                res = n - (len + bef[i] + aft[j]);
        }*/
    }

    cout << res << endl;
}

int main()
{
    speed();
    solve();

    return 0;
}
