#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if( false ) cerr
#endif

#define out(x) #x << " = " << x << "  "

int n;
double avg;

const int MAX_N = 1e6 + 42;
const double eps = 0.0001;
int a[MAX_N];

std::vector< int > nas;

double divide(long long x, long long y)
{
    return ((1.0 * x) / (1.0 * y));
}

bool f( int x ){

    cerr << " !!! " << x << endl;
    int l = x-1;
    int r = x+1;

    long long sum = a[x];
    int cnt = 1;

    double currAvg = divide(sum, cnt);
    if( currAvg > avg ) return false;

    std::vector< int > currNas;
    currNas.push_back( x );
    while( true ){

        if( l == -1 and r >= n ) break;

        if( l == -1 ){
            currNas.push_back( r );
            sum += a[r++];
        }else if( r == n ){
            currNas.push_back( l );
            sum += a[l--];
        }else if( a[l] < a[r] ){
            currNas.push_back( l );
            sum += a[l--];
        }else{
            currNas.push_back( r );
            sum += a[r++];
        }
        cnt ++;
        currAvg = divide(sum, cnt);

        cerr << l << " " << r << " " << sum << " " << cnt << endl;
        cerr << std::fixed << setprecision( 3 ) << currAvg << " " << avg << endl << endl;

        if( currAvg - avg > eps ){
            return false;
        }
    }

    /*
    for( auto j : currNas ) cerr << j << " ";
    cerr << endl;
    */

    nas = currNas;
    return true;
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    std::cin >> n;

    long long sum = 0;
    for( int i=0 ; i < n ; i++ ){
        std::cin >> a[i];
        sum += a[i];
    }

    cerr << out( sum ) << out( n ) << endl;
    avg = divide(sum, n);
    cerr << out( avg ) <<endl;

    for( int i=0 ; i < n ; i++ ){
        if( f( i ) ) break;
    }

    if( nas.size() ){
        for( auto j : nas ) std::cout << j +1 << " ";
        std::cout << endl;
    }else{
        std::cout << "impossible" << endl;
    }


    return 0;
}
