#include <bits/stdc++.h>

using namespace std;

const int maxn = 1005;
const double eps = 1e-9;

int n;
long long a[maxn], pref[maxn];
double avg;

bool isBigger(double x, double y)
{
    //cout << "here " << x - y << " " << -eps << " :: " << (x - y >= eps || fabs(x - y) <= eps) << endl;
    return x - y >= eps; ///eps
}

bool can(long long sum, int cnt)
{
    double currAvg = ((1.0 * sum) / (1.0 * cnt));
    return currAvg - avg <= eps;
}

long long sumA(int l, int r)
{
    return pref[r] - pref[l - 1];
}

bool dp[maxn][maxn];
bool bl[maxn][maxn];

bool f(int from, int to)
{
    if (can(pref[to] - pref[from - 1], to - from + 1) == false) return false;
    if (from == 1 && to == n) return true;
    if (bl[from][to] == true) return dp[from][to];
    bl[from][to] = true;

    dp[from][to] = false;

    if (from > 1 && can(sumA(from - 1, to), to - from + 2))
    {
        dp[from][to] |= f(from - 1, to);
    }

    if (to < n && can(sumA(from, to + 1), to - from + 2))
    {
        dp[from][to] |= f(from, to + 1);
    }

    return dp[from][to];
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    long long sum = 0;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sum += a[i];
        pref[i] = pref[i - 1] + a[i];
    }

    avg = ((sum * 1.0) / (n * 1.0));

    for (int i = 1; i <= n; ++i)
    {
        if (f(i, i))
        {
            vector<int> nas;
            nas.push_back(i);
            int l = i, r = i;

            while (!(l == 1 && r == n))
            {
                if (l == 1) nas.push_back(++r);
                else if (r == n) nas.push_back(--l);
                else if (f(l - 1, r)) nas.push_back(--l);
                else if (f(l, r + 1)) nas.push_back(++r);
            }

            for (auto x : nas) cout << x << " ";
            cout << endl;
            return 0;
        }
    }

    cout << "impossible" << endl;

    return 0;
}
