#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;
const double eps = 1e-6;

int n;
long long a[maxn];
double avg;

bool isBigger(double x, double y)
{
    //cout << "here " << x - y << " " << -eps << " :: " << (x - y >= eps || fabs(x - y) <= eps) << endl;
    return x - y >= eps; ///eps
}

bool can(long long sum, int cnt)
{
    double currAvg = ((1.0 * sum) / (1.0 * cnt));
    return currAvg - avg <= eps;
}


bool oke = false;
void f(int pos)
{
    if (isBigger(a[pos], avg)) return;

    int l = pos - 1;
    int r = pos + 1;
    long long sum = a[pos];
    int cnt = 1;

    vector<int> nas;
    nas.push_back(pos);

    while (true)
    {
        //cout << pos << " " << l << " " << r << endl;
        if (l == 0 && r == n + 1) break;

        if (l == 0)
        {
            sum += a[r];
            nas.push_back(r);
            ++r;
        }
        else if (r == n + 1)
        {
            sum += a[l];
            nas.push_back(l);
            --l;
        }
        else
        {
            bool canLeft = can(sum + a[l], cnt + 1);
            bool canRight = can(sum + a[r], cnt + 1);
            //cout << canLeft << " " << canRight << endl;

            if (!canLeft && !canRight) return;

            if (canLeft && !canRight)
            {
                sum += a[l];
                nas.push_back(l);
                --l;
            }
            else if (!canLeft && canRight)
            {
                sum += a[r];
                nas.push_back(r);
                ++r;
            } else if (a[l] > a[r])
            {
                sum += a[l];
                nas.push_back(l);
                --l;
            }
            else
            {
                sum += a[r];
                nas.push_back(r);
                ++r;
            }
        }

        ++cnt;
        double currAvg = ((1.0 * sum) / (1.0 * cnt));

        if (isBigger(currAvg, avg)) return;
    }

    oke = true;
    for (auto i : nas) cout << i << " ";
    cout << endl;
    exit(0);
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    long long sum = 0;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        sum += a[i];
    }

    avg = ((sum * 1.0) / (n * 1.0));

    double beg = clock();

    while( true ){

        int i = rand() % n + 1;
        f(i);

        double ed = clock();
        double currTime = double( ed - beg ) / CLOCKS_PER_SEC;
        if( currTime > 0.085) break;
    }

    cout << "impossible" << endl;

    return 0;
}
