#include<bits/stdc++.h>
#define MAXN 100000
#define LOGN 18
using namespace std;
int n,m;
unordered_set<int> za1[MAXN];
vector<int> rebra[MAXN];
int chis[MAXN];
int jump[MAXN][LOGN];
int depth[MAXN];
void dfs(int node, int par, int d)
{
    depth[node] = d;
    if (node == 1) jump[node][0] = node;
    else jump[node][0] = par;

    for (auto to : rebra[node])
    {
        if (to != par)
        {
            dfs(to, node, d + 1);
        }
    }
}

int lca(int& x,int& y)
{
    if (depth[x] < depth[y]) swap(x, y);
    int diff = depth[x] - depth[y];

    for (int i = 0; i < LOGN; ++i)
    {
        if ((diff & (1 << i)) != 0)
        {
            x = jump[x][i];
            diff -= (1 << i);
            if (diff == 0) break;
        }
    }

    if (x == y) return x;

    for (int i = LOGN - 1; i >= 0; --i)
    {
        if (jump[x][i] != jump[y][i])
        {
            x = jump[x][i];
            y = jump[y][i];
        }
    }

    return jump[x][0];
}
int curans[MAXN];
bool fn[MAXN];
void ans(int x,int p){
    int da=0;
    for(int i=0;i<rebra[x].size();i++){
        int rx=rebra[x][i];
        if(rx==p) continue;
        if(chis[rx]!=0){
            da++;
        }
        ans(rx,x);
        curans[x]*=curans[rx];
    }
    if(x!=1){
        if(da>1) curans[x]=0;
        if(da==0 && rebra[x].size()==3) curans[x]*=2;
    }else{
        int curr=curans[x];
        curans[x]=0;
        do{
            bool daa=false;
            for(int i=0;i<rebra[x].size();i++){
                int rx=rebra[x][i];
                fn[rx]=true;
             //   cout<<rx<<" ";
                for(auto it = za1[rx].begin(); it != za1[rx].end(); ++it){
                    if(!fn[*it]){
                        daa=true;
                        break;
                    }
                }
                if(daa) break;
            }
            for(int i=0;i<rebra[x].size();i++){
                fn[rebra[x][i]]=false;
            }
            if(!daa){
                curans[x]+=curr;
            }
        }while(next_permutation(rebra[x].begin(),rebra[x].end()));
    }
  //  cout<<x<<" "<<curans[x]<<"\n";
}
int main(){
    cin>>n>>m;
    for(int i=0;i<n-1;i++){
        curans[i+1]=1;
        int x,y;
        cin>>x>>y;
        rebra[x].push_back(y);
        rebra[y].push_back(x);
    }
    curans[n]=1;
    dfs(1, 0, 0);

    for (int log = 1; log < LOGN; ++log)
    {
        for (int i = 1; i <= n; ++i)
        {
            jump[i][log] = jump[jump[i][log - 1]][log - 1];
        }
    }
    for(int i=0;i<m;i++){
        int x,y,xx,yy;
        cin>>x>>y;
        xx=x;
        yy=y;
        int lc=lca(x,y);
       // cout<<x<<" i "<<y<<"\n";
        if(lc==xx) continue;
        if(lc==yy){
            cout<<0<<"\n";
            return 0;
        }
        if(lc==1){
            za1[y].insert(x);
        }
        chis[y]=x;
    }
    ans(1,-1);
    cout<<curans[1]<<"\n";
    return 0;
}
