#include<bits/stdc++.h>
#define MAXN 100001
#define LOGN 18
using namespace std;
long long n,m;
const long long mod=1000000007;
unordered_set<long long> za1[MAXN];
vector<long long> rebra[MAXN];
long long chis[MAXN];
long long jump[MAXN][LOGN];
long long depth[MAXN];
void dfs(long long node, long long par, long long d)
{
    depth[node] = d;
    if (node == 1) jump[node][0] = node;
    else jump[node][0] = par;

    for (auto to : rebra[node])
    {
        if (to != par)
        {
            dfs(to, node, d + 1);
        }
    }
}
bool sw=false;
long long lca(long long& x,long long& y)
{
    if (depth[x] < depth[y]){
        swap(x, y);
        sw=true;
    }
    long long diff = depth[x] - depth[y];

    for (long long i = 0; i < LOGN; ++i)
    {
        if ((diff & (1 << i)) != 0)
        {
            x = jump[x][i];
            diff -= (1 << i);
            if (diff == 0) break;
        }
    }

    if (x == y) return x;

    for (long long i = LOGN - 1; i >= 0; --i)
    {
        if (jump[x][i] != jump[y][i])
        {
            x = jump[x][i];
            y = jump[y][i];
        }
    }

    return jump[x][0];
}
long long curans[MAXN];
bool fn[MAXN];
void ans(long long x,long long p){
    long long da=0;
    for(long long i=0;i<rebra[x].size();i++){
        long long rx=rebra[x][i];
        if(rx==p) continue;
        if(chis[rx]!=0){
            da++;
        }
        ans(rx,x);
        curans[x]=(curans[x]*curans[rx])%mod;
    }
    if(x!=1){
        if(da>1) curans[x]=0;
        if(da==0 && rebra[x].size()==3) curans[x]=(curans[x]*2)%mod;
    }else{
        long long curr=curans[x];
        curans[x]=0;
        bool daa=false;
        do{
            for(long long i=0;i<rebra[x].size();i++){
                fn[rebra[x][i]]=false;
            }
            bool daa=false;
            for(long long i=0;i<rebra[x].size();i++){
                long long rx=rebra[x][i];
                fn[rx]=true;
               // cout<<rx<<" ";
                for(auto it = za1[rx].begin(); it != za1[rx].end(); ++it){
                    if(!fn[*it]){
                        daa=true;
                        break;
                    }
                }
                if(daa) break;
            }
            if(!daa){
                curans[x]=(curans[x]+curr)%mod;
                //cout<<" da\n";
            }
            //cout<<"\n";
        }while(next_permutation(rebra[x].begin(),rebra[x].end()));
    }
  //  cout<<x<<" "<<curans[x]<<"\n";
}
int main(){
    cin>>n>>m;
    for(long long i=0;i<n-1;i++){
        curans[i+1]=1;
        long long x,y;
        cin>>x>>y;
        rebra[x].push_back(y);
        rebra[y].push_back(x);
    }
    curans[n]=1;
    dfs(1, 0, 0);

    for (long long log = 1; log < LOGN; ++log)
    {
        for (long long i = 1; i <= n; ++i)
        {
            jump[i][log] = jump[jump[i][log - 1]][log - 1];
        }
    }
    for(long long i=0;i<m;i++){
        long long x,y,xx,yy;
        cin>>x>>y;
        xx=x;
        yy=y;
        sw=false;
        long long lc=lca(x,y);
       // cout<<x<<" i "<<y<<"\n";
        if(sw) swap(x,y);
        if(lc==xx) continue;
        if(lc==yy){
            cout<<0<<"\n";
            return 0;
        }
        if(lc==1){
            za1[y].insert(x);
        }
        chis[y]=x;
    }
    ans(1,-1);
    cout<<curans[1]<<"\n";
    return 0;
}
